package com.hackthon.interceptor;

import java.util.List;

import org.apache.flume.Context;
import org.apache.flume.Event;
import org.apache.flume.interceptor.Interceptor;

/*
* The InterceptorParser class parses the event at source level and sends back to channel.
*  
* @version 1.0
*/

public class HkthonIntercepParser implements Interceptor {
	private String parsedData;

	@Override
	public void close() {

	}

	@Override
	public void initialize() {

	}

	@Override
	public Event intercept(Event event) {

		String eventXML = new String(event.getBody());
		try {
			parsedData = HackthonInterceptor.getXMLParsingData(eventXML);
		} catch (Throwable e) {

			e.printStackTrace();
		}
		byte[] modifiedEvent = parsedData.getBytes();

		event.setBody(modifiedEvent);

		return event;
	}

	@Override
	public List<Event> intercept(List<Event> events) {

		for (Event event : events) {

			intercept(event);
		}

		return events;
	}

	public static class Builder implements Interceptor.Builder {

		@Override
		public void configure(Context context) {

		}

		@Override
		public Interceptor build() {
			return new HkthonIntercepParser();
		}
	}

}
