package com.hackthon.hbase.ingestion;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import org.apache.flume.Context;
import org.apache.flume.Event;
import org.apache.flume.conf.ComponentConfiguration;
import org.hbase.async.AtomicIncrementRequest;
import org.hbase.async.PutRequest;

public class HKthonHbaseSerializer implements org.apache.flume.sink.hbase.AsyncHbaseEventSerializer {
	private byte[] table;
	private byte[] currentRowKey;
	private Event currentEvent;
	private String rowKey;
	private byte[] colFamily;
	private List<PutRequest> puts = new ArrayList<PutRequest>();
	private final List<AtomicIncrementRequest> incs = new ArrayList<AtomicIncrementRequest>();
	private final byte[] eventCountCol = "eventCount".getBytes();
	private static String TOTAL_EVENTS = "totalEvents";
	public void configure(Context context) {
		context.getString("column");
	}

	public void configure(ComponentConfiguration arg0) {
	}

	public void cleanUp() {
		table = null;
		colFamily = null;
		currentEvent = null;
		currentRowKey = null;
	}

	public List<PutRequest> getActions() {

		System.out.println("column family:" +colFamily);
		String eventXML = new String(currentEvent.getBody());
		
		System.out.println("event data:"+eventXML);
		
		
		puts.clear();
		String[] results = eventXML.split(",");
		System.out.println("total elements:"+results.length);
		if (results.length==4)
		{
		try {
			
			
			long timeStmp = Long.parseLong(results[2]);
			
			Calendar calendar = Calendar.getInstance();
			calendar.setTimeInMillis(timeStmp);

			int mYear = calendar.get(Calendar.YEAR);
			int mMonth = calendar.get(Calendar.MONTH);
			int mDay = calendar.get(Calendar.DAY_OF_MONTH);
			int mHr = calendar.get(Calendar.HOUR_OF_DAY);
			int mMin = calendar.get(Calendar.MINUTE);
			int mSec = calendar.get(Calendar.SECOND);
			int mMSec = calendar.get(Calendar.MILLISECOND);
			System.out.println("###################### check here ###############");
			System.out.println("###################### check here ###############");
			System.out.println("###################### check here ###############");
			System.out.println("timeStamp in milli:"+results[2]+ "-converted to:"+ mYear+ " " + mMonth+ " "+ mDay+" "+ mHr+ " "+mMin+ " " + mSec+" "+mMSec);
			//rowKey = mYear + "-"+mMonth+"-"+mDay+"-"+mHr+"-"+mMin+"-"+mSec+"-"+mMSec+"-"+results[0]+"-"+results[1];
			rowKey = results[0]+"-"+results[1]+"+"+results[2];
			//String Value1 = results[0]+"-"+results[1];
			//String Value2 = results[3];
			//String Value3 = mMonth+"-"+mDay+"-"+mHr;
			//String FullValue = Value3 + "+" + Value1 + "+" + Value2;
			//rowKey = results[0]+"-"+results[1]+"-"+results[2];
			currentRowKey = rowKey.getBytes();
			
			PutRequest HouseID = new PutRequest(table, currentRowKey, colFamily, "houseID".getBytes(), results[0].getBytes());
			PutRequest HouseHoldID = new PutRequest(table, currentRowKey, colFamily, "houseHoldID".getBytes(), results[1].getBytes());
			PutRequest Power = new PutRequest(table, currentRowKey, colFamily, "powerConsumed".getBytes(), results[3].getBytes());
			PutRequest Year = new PutRequest(table, currentRowKey, colFamily, "year".getBytes(), String.valueOf(mYear).getBytes());
			PutRequest Month = new PutRequest(table, currentRowKey, colFamily, "month".getBytes(), String.valueOf(mMonth).getBytes());
			PutRequest Day = new PutRequest(table, currentRowKey, colFamily, "day".getBytes(), String.valueOf(mDay).getBytes());
			PutRequest Hour = new PutRequest(table, currentRowKey, colFamily, "hour".getBytes(), String.valueOf(mHr).getBytes());			
			
			puts.add(HouseID);
			puts.add(HouseHoldID);
			puts.add(Power);
			puts.add(Year);
			puts.add(Month);
			puts.add(Day);
			puts.add(Hour);
			

			
			}
		 catch (Throwable e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			//return puts;
		 }
		}
		return puts;
		
	}
	public List<AtomicIncrementRequest> getIncrements() {
		incs.clear();
		incs.add(new AtomicIncrementRequest(table, TOTAL_EVENTS.getBytes(), colFamily, eventCountCol));
		return incs;
	}

	public void initialize(byte[] table, byte[] colFamily) {
		this.table = table;
		this.colFamily = colFamily;
	}

	public void setEvent(Event event) {
		currentEvent = event;
	}
}