package com.hackthon.hbase.ingestion;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import org.apache.flume.Context;
import org.apache.flume.Event;
import org.apache.flume.conf.ComponentConfiguration;
import org.hbase.async.AtomicIncrementRequest;
import org.hbase.async.PutRequest;

public class HKthonHbaseSerializer_old implements org.apache.flume.sink.hbase.AsyncHbaseEventSerializer {
	private byte[] table;
	@SuppressWarnings("unused")
	private byte[] currentRowKey, colFam;
	private Event currentEvent;
	private String rowKey, colName;
	private String colFamily="colFM";
	private List<PutRequest> puts = new ArrayList<PutRequest>();
	private final List<AtomicIncrementRequest> incs = new ArrayList<AtomicIncrementRequest>();
	private final byte[] eventCountCol = "colFM".getBytes();
	private static String TOTAL_EVENTS = "totalEvents";
	public void configure(Context context) {
		colName = context.getString("columns");
		
	}

	public void configure(ComponentConfiguration arg0) {
	}

	public void cleanUp() {
		table = null;
		colFamily = null;
		currentEvent = null;
		currentRowKey = null;
	}

	public List<PutRequest> getActions() {
		System.out.println("###########################");
		System.out.println("###########################");
		System.out.println("###########################");
		System.out.println("column family:" +colFamily);
		String eventXML = new String(currentEvent.getBody());
		
		System.out.println("event data:"+eventXML);
		
		
		puts.clear();
		String[] results = eventXML.split(",");
		System.out.println("total elements:"+results.length);
		if (results.length==4)
		{
		try {
			
			
			long timeStmp = Long.parseLong(results[2]);
			
			Calendar calendar = Calendar.getInstance();
			calendar.setTimeInMillis(timeStmp);

			int mYear = calendar.get(Calendar.YEAR);
			int mMonth = calendar.get(Calendar.MONTH);
			int mDay = calendar.get(Calendar.DAY_OF_MONTH);
			
			rowKey = results[0]+"-"+results[1]+"-"+mYear + "-"+mMonth+"-"+mDay;
			currentRowKey = rowKey.getBytes();

			PutRequest req = new PutRequest(table, currentRowKey, colFamily.getBytes(), colName.getBytes(), results[3].getBytes());
			puts.add(req);

			
			}
		 catch (Throwable e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			//return puts;
		 }
		}
		return puts;
		
	}

	public List<AtomicIncrementRequest> getIncrements() {
		incs.clear();
		incs.add(new AtomicIncrementRequest(table, TOTAL_EVENTS.getBytes(), colFamily.getBytes(), eventCountCol));
		return incs;
	}

	public void initialize(byte[] table, byte[] colFam) {
		this.table = table;
		System.out.println("colFM:"+colFam);
		this.colFamily = colFam.toString();
	}

	public void setEvent(Event event) {
		currentEvent = event;
	}
}